/***************************************************************************
                          wrapper.h  -  description
                             -------------------
    begin                : Fri Nov 26 1999
    copyright            : (C) 1999 by fflewddur
    email                : fflewddur@linuxfreak.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef WRAPPER
#define WRAPPER

/* Wrapper functions that include error checking, making my life easier */

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <signal.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>

#define SA sockaddr
#define SA_IN sockaddr_in

typedef void Sigfunc(int);

int Socket(int family, int type, int protocol);
int Connect(int sockfd, const struct SA * addr, socklen_t addrlen);
int Bind(int sockfd, const struct SA * addr, socklen_t addrlen);
int Listen(int sockfd, int backlog);
int Accept(int sockfd, struct SA * addr, socklen_t *addrlen);
int Inet_pton(int family, const char *string, void *addr);
const char * Inet_ntop(int family, const void *addr, char *string, size_t
len);
struct hostent *Gethostbyname(const char *hostname);
struct servent *Getservbyport(int port, char *protocol);
int Setsockopt(int sockdf, int level, int optname, const void *optval, socklen_t optlen);
ssize_t Sendto(int sockfd, const void *buffer, size_t nbytes, int flags, const struct SA *to, socklen_t addrlen);
ssize_t Recvfrom(int sockfd, void *buffer, size_t nbytes, int flags, struct SA *from, socklen_t *addrlen);

#endif
